// TsTimeKeeper.cpp : R\[ AvP[ṼGg |Cg`܂B
// TsTimeKeeper 3.3.14.9

#include "stdafx.h"
#include <stdlib.h>
#include <windows.h>
#include "tsPacket.h"
#include "TsFileRead.h"

//\
struct TsPacket{
	__int64 difValueGOPPTSBASE;
	__int64 startPCR;
	int		PCRPID;
	int		VIDEOPID;
	int		AUDIOPID;
	byte*	nVideo;			
};

// 萔
const int nvideoSize = 188 * 2048; // f[^i[pz188X8192 188X4096=&HBC000 188X2048=5E000

// vg^Cv錾
bool getInfoFromFile( TsFileRead*, TsPacket* );
bool TimeKeep( TsFileRead*, _TCHAR*, TsPacket* );

// C
int _tmain(int argc, _TCHAR* argv[])
{
	//p[^`FbN
	if ( argc == 1 ){
		fprintf(stderr,"TsTimeKeeper Ver3.3.14.9(32bit)\n");
		exit(1);
	}
	int	argSrc = 1;
	int	argDest = 2;
	SYSTEMTIME stTime;
    TsPacket tsp;

	tsp.nVideo = ( byte* )malloc((size_t)(nvideoSize));
	if(tsp.nVideo == NULL){
		fprintf(stderr, "Ǎ݃obt@̊mۂɎs܂.\n");
		exit(1);
	}

	tsp.PCRPID = -1;
	tsp.VIDEOPID = -1;
	tsp.AUDIOPID = -1;
	tsp.startPCR = 324000000LL * 300;
	
	GetLocalTime(&stTime);

	fprintf(stdout, "Jn %d%d%db\n", stTime.wHour, stTime.wMinute , stTime.wSecond);
	fflush(stdout);

	TsFileRead	inpfile(argv[argSrc]);

	if( !getInfoFromFile(&inpfile, &tsp)){
		free(tsp.nVideo);
		exit(1);
	}

	if( !TimeKeep(&inpfile, argv[argDest], &tsp)){
		free(tsp.nVideo);
		exit(1);
	}

	GetLocalTime(&stTime);

	fprintf(stdout,"I %d%d%db\n", stTime.wHour, stTime.wMinute , stTime.wSecond);
	fflush(stdout);
	free(tsp.nVideo);
	exit( 0 );

}
// 
//   PAT,PMT(PCRPID,VideoPID,AudioPID,GOP
bool getInfoFromFile(TsFileRead* file, TsPacket* tsp)
{
	int		readSize;
	int		nBuffPoint;
	int		errMes = 0;
    int     adpBytes;
    bool    bPAT = false;
    bool    bPMT = false;
    bool    bGOP = false;
    bool	bGOPFirst = true;
    bool    bPCR = false;
	int		PMTPID = -1;
	int		PMTPIDCount = 0;
    bool    bPCRPID = false;
	int		VideoPIDCount = 0;
    bool    bVideoPID = false;
	int		AudioPIDCount = 0;
    bool    bAudioPID = false;
	int		iPPID;

	file->Seek(0);
	readSize = file->Read(tsp->nVideo, nvideoSize);

	nBuffPoint = -188;

	while( 1 ){
		fprintf(stdout,"PAT,PMT,PCR,GOP@ %d%% \r",(nBuffPoint * 100) / nvideoSize);
		fflush(stdout);
		while( 1 ){
			nBuffPoint += 188;

			if( readSize - 1 < nBuffPoint)
			{
				fprintf(stderr,"t@CjĂ\܂...I܂.\n");
				fflush(stderr);
				return false;
			}

			iPPID =((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];	// vOPID
            //If nVideo(nBuffPoint) = &H47 Then
			if( tsp->nVideo[nBuffPoint + 1] & 0x40 ){	// Payload Start
				// vOPID"00"ȂPAT(e[u(00)+ZNVV^NXw(1)+0+11ȂPAT)
				if( iPPID == 0 ){
					if( bPMT == false ){
						//if (nVideo[nBuffPoint + 5] * 0x10 + (nVideo[nBuffPoint + 6] & 0xf0) / 0x10 == 0xb){	//e[u(00)+ZNVV^NXw(1)+0+1
						if( 0xb == (tsp->nVideo[nBuffPoint + 5] << 4)+ ((tsp->nVideo[nBuffPoint + 6] & 0xf0) >> 4)){		//e[u(00)+ZNVV^NXw(1)+0+1
							int secLength = ((tsp->nVideo[nBuffPoint + 6] & 0xf) << 8 ) + tsp->nVideo[nBuffPoint + 7] - 9;
							int offSet = 0;
							while( offSet < secLength){
								//ԑgԍ
								if(0 != tsp->nVideo[nBuffPoint + offSet + 13] + tsp->nVideo[nBuffPoint + offSet + 14]){
									int tmpPMTPID = ((tsp->nVideo[nBuffPoint + offSet + 15] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + offSet + 16];
									if(PMTPID != tmpPMTPID){
										PMTPID = tmpPMTPID;
										PMTPIDCount++;
									}
								}
								offSet += 4;
							}
							bPAT = true;

							if( PMTPIDCount == 0 ){
								fprintf(stderr,"t@CjĂ\܂...I܂.\n");
								fflush(stderr);
								return false;
							}
							else if( PMTPIDCount == 1 ){
								errMes = 0;
								continue;
							}
							else{
								fprintf(stderr,"̉f܂܂Ă܂...ł܂.\n");
								fflush(stderr);
								return false;
 							}
						}
					}
				}

				// vOPIDPMTPID( e[u(02)+ZNVV^NXw(1)+0+11ȂPMT)
				else if( iPPID == PMTPID ){
					if( bPMT == false ){
						if(0x2b == (tsp->nVideo[nBuffPoint + 5] << 4) + ((tsp->nVideo[nBuffPoint + 6] & 0xf0) >> 4)){
							//PCR_PID = (nVideo(nBuffPoint + 13) And &H1F) * &H100 + nVideo(nBuffPoint + 14)
							tsp->PCRPID = ((tsp->nVideo[nBuffPoint + 13] & 0x1f) << 8) + tsp->nVideo[nBuffPoint + 14];
 							bPCRPID = true;
							//e[u(5byte)
							//ZNV(6Byteډ4Bit+7Byte)
							int secLength = ((tsp->nVideo[nBuffPoint + 6] & 0xf) << 8) + tsp->nVideo[nBuffPoint + 7];
							secLength -= (((tsp->nVideo[nBuffPoint + 15] & 0xf) << 8) + tsp->nVideo[nBuffPoint + 16] + 12);
							//12 CRC:4Byte ԑg:2Byte...ZNVԍ:1Byte...'1111'+ԑg:2Byte
							int nBase = ((tsp->nVideo[nBuffPoint + 15] & 0xf) << 8) + tsp->nVideo[nBuffPoint + 16] + 17;
							//17  12+wb_[:4Byte+1
							int offSet = 0;
							while( offSet < secLength){
								//Xg[` 
								int stmID = tsp->nVideo[nBuffPoint + nBase + offSet];
								int tmpPID = ((tsp->nVideo[nBuffPoint + nBase + offSet + 1] & 0x1f) << 8) + tsp->nVideo[nBuffPoint + nBase + offSet + 2];
								if( 2 == stmID ){   
								//f
									if( tsp->VIDEOPID != tmpPID ){
										tsp->VIDEOPID = tmpPID;
										VideoPIDCount++;
									}
								}
								else if( 0xf == stmID ){
								//
									if (tsp->AUDIOPID != tmpPID){
										tsp->AUDIOPID = tmpPID;
										AudioPIDCount++;
									}
								}
								offSet += (((tsp->nVideo[nBuffPoint + nBase + offSet + 3] & 0xf) << 8) + tsp->nVideo[nBuffPoint + nBase + offSet + 4] + 5);
							}
							bPMT = true;
						}
					}
				}

				//GOP,VideoPID,AudioPID
				else if( tsp->nVideo[nBuffPoint + 3] & 0x10 ){	// payload exists
					//A_ve[VĂpPbg
					adpBytes = 0;
					if(tsp->nVideo[nBuffPoint + 3] & 0x20){
						adpBytes = tsp->nVideo[nBuffPoint + 4] + 1;
					}
					//pPbgX^[gR[h(000001)
					if(0 == tsp->nVideo[nBuffPoint + adpBytes + 4] + tsp->nVideo[nBuffPoint + adpBytes + 5] ){
						if(1 == tsp->nVideo[nBuffPoint + adpBytes + 6]){
							if(0x80 == (tsp->nVideo[nBuffPoint + adpBytes + 10] & 0xc0)){
								int x = tsp->nVideo[nBuffPoint + adpBytes + 7];   //streamID
								if( (x & 0xf0) == 0xe0 ){                 //f
									int tmpPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
									if(tsp->VIDEOPID != tmpPID){
										tsp->VIDEOPID = tmpPID;
										VideoPIDCount++;
									}
									x = tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0;				//PTS=&H80 DTS=&H40
									//If nVideo(nBuffPoint + adpBytes + 13) And &HF0 Then        '4bit 0010 PTS only   0011 DTS follows
									if( x & 0x80 ){
										bVideoPID = true;
									}
									if( x & 0x40 ){
										bGOP = true;
									}
									if( !bGOP){
										fprintf(stderr,"t@C̐擪GOPŋ؂Ă܂...I܂.\n");
										fflush(stderr);
										return false;
									}
								}
								else if( (x & 0xe0) == 0xc0 ){            //
									int tmpPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
									if(tsp->AUDIOPID != tmpPID){
										tsp->AUDIOPID = tmpPID;
										AudioPIDCount++;
									}
									bAudioPID = true;
									if( !bGOP ){
										fprintf(stderr,"t@C̐擪GOPŋ؂Ă܂...I܂.\n");
										fflush(stderr);
										return false;
									}
								}
							}
						}
					}
				}
			}

			//PCŘ
			else if( iPPID == tsp->PCRPID ){
               if( tsp->nVideo[nBuffPoint + 3] & 0x20 ){		//adaptation field exists
                    if( tsp->nVideo[nBuffPoint + 5] & 0x10 ){	//PCR flag
                        //'Ԏ擾
                        tsp->difValueGOPPTSBASE = (getValuePCR(tsp->nVideo, nBuffPoint) - tsp->startPCR) / 300;
                        bPCR = true;
					}
				}
			}

			if( bPAT &&	bPMT && bGOP && bVideoPID && bAudioPID && bPCR ){
				break;
			}

		}	//while

        if( 0 != errMes ){
			break;
		}

		if( VideoPIDCount == 0 ){
			errMes = 1;
			bVideoPID = false;
			break;
		}
		else if( VideoPIDCount == 1 ){
			//Ȃ
		}
		else{
			errMes = 3;
			bVideoPID = false;
			break;
		}

		if( AudioPIDCount == 0 ){
			errMes = 1;
			bAudioPID = false;
			break;
		}
		else if(AudioPIDCount == 1 ){
			//Ȃ
			break;
		}
		else{
			errMes = 3;
			bAudioPID = false;
			break;
		}
		
	}

    if( errMes == 0 ){
		fprintf(stdout,"PAT,PMT,PCR,GOPI 100%% \n");
		fflush(stdout);
	}
	else if( errMes == 1 ){
		fprintf(stderr,"t@CjĂ\܂...I܂.\n");
		fflush(stderr);
		return false;
	}
	else if( errMes == 2 ){
		fprintf(stderr,"t@C̐擪GOPŋ؂Ă܂...I܂.\n");
		fflush(stderr);
		return false;
	}
	else if( errMes == 3 ){
		fprintf(stderr,"̉f܂܂Ă܂...ł܂.\n");
		fflush(stderr);
		return false;
	}

	return true;

}
//
//ύX{
bool TimeKeep(TsFileRead* inpfile, _TCHAR* destName, TsPacket* tsp)
{
	TsFileWrite	outfile(destName);
	int		nBuffPoint;
	__int64	nFilePoint;
	int		readSize;
	int		adpBytes;
    bool	foundVideoPTS;
    bool	foundGOP;
    bool	foundAudioPTS;
    bool	foundPCR;
    __int64	nowValuePCR;
    __int64	setValuePCR;
    __int64	prevValueGOPPTS;
    __int64	nowValueGOPPTS = 0;
    __int64	setValueGOPPTS;
    __int64	nowValuePTS;
    __int64	setValuePTS;
    __int64	nowValueDTS;
    __int64	setValueDTS;
//    __int64	difValueGOPPTSBASE;
    __int64	prevdifValueGOPPTSBASE;
    __int64	difValueGOPPTS;
	__int64	numGOP = 0;
	__int64 fSize = inpfile->Size();
	__int64 nlCount = 0;
	int nowPercent = -1;
	int newPercent;
	MSG msg;
	int iPID;
	bool bJoint = false;

    nBuffPoint = -188;
    nFilePoint = -188;

//	readSize = inpfile->Read(tsp->nVideo, nvideoSize);
 	readSize = nvideoSize;
	fprintf(stdout,"PCR,PTS,DTSXV@ 0%% \r" );
	fflush(stdout);

	while( 1 ){
		if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) {
			TranslateMessage( &msg );
			DispatchMessage(&msg);
		}

		newPercent =(int)((nFilePoint * 100) / fSize);
		if( nowPercent != newPercent ){
			nowPercent = newPercent;
			fprintf(stdout,"PCR,PTS,DTSXV@ %d%% \r", nowPercent);
			fflush(stdout);
		}
		while( 1 ){
			nBuffPoint += 188;
            nFilePoint += 188;

			if( (readSize - 1 < nBuffPoint) || bJoint ){
				if( bJoint ){
					nBuffPoint -= 188;
					nFilePoint -= 188;

					//
					outfile.Write(tsp->nVideo, nBuffPoint);
					memcpy(tsp->nVideo,tsp->nVideo + nBuffPoint,readSize - nBuffPoint);
					
					//Ǎ
					readSize = inpfile->Read(tsp->nVideo + ( readSize - nBuffPoint),  nBuffPoint) + readSize - nBuffPoint;
					nBuffPoint = 0;
					//PCR
					while( bJoint ){
						if(tsp->PCRPID == ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2] ){
							//adaptation field exists
							if( tsp->nVideo[nBuffPoint + 3] & 0x20 ){
								//'PCR flag
								if(tsp->nVideo[nBuffPoint + 5] & 0x10){
									//PCRݒ
									//ȂڂȂ̂50ms(1350000)ŒƂ
									setValuePCR += 1350000;
									tsp->difValueGOPPTSBASE = (getValuePCR(tsp->nVideo,nBuffPoint) - setValuePCR) / 300;
									nBuffPoint = 0;
									bJoint = false;
									break;
                   				}
							}
						}
						nBuffPoint += 188;
						if( readSize-1 < nBuffPoint )
							break;
					}
					if( 0 < nBuffPoint ){
						fprintf(stderr,"t@CjĂ\܂...I܂.\n");
						fflush(stderr);
						return false;
					}
				}
				else{
					//
					outfile.Write(tsp->nVideo, readSize);
					//Ǎ
					readSize = inpfile->Read(tsp->nVideo, nvideoSize);
					nBuffPoint = 0;
					if( 0 == readSize ){
						break;
					}
				}
			}

            foundPCR = false;
            foundGOP = false;
            foundVideoPTS = false;
            foundAudioPTS = false;

			iPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2] ;
			if( tsp->nVideo[nBuffPoint + 1] & 0x40 ){				//Payload starts
				//fPST(GOP)
				if( iPID == tsp->VIDEOPID ){
                    //A_ve[VĂpPbg
					adpBytes = 0;
					if( tsp->nVideo[nBuffPoint + 3] & 0x20 ){
						adpBytes = tsp->nVideo[nBuffPoint + 4] + 1;
					}
 					if( tsp->nVideo[nBuffPoint + 3] & 0x10 ){       //payload exists
                       //pPbgX^[gR[h(000001)
                        if( 0 == tsp->nVideo[nBuffPoint + adpBytes + 4] + tsp->nVideo[nBuffPoint + adpBytes + 5]){
							if( 1 == tsp->nVideo[nBuffPoint + adpBytes + 6] ){ 
								if( 0x80 == (tsp->nVideo[nBuffPoint + adpBytes + 10] & 0xc0) ){
									int x = tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0;     //PTS=&H80 DTS=&H40
									//x = nVideo(nBuffPoint + adpBytes + 13) And &HF0			//PTS +DTS
									if( x & 0x80 ){					//PTS
										foundVideoPTS = true;
										if( x & 0x40 ){				//DTS
											foundVideoPTS = false;
											foundGOP = true;
											numGOP++;
										}
										break;
									}
                  				}
							}
						}
					}
				}

				//PTS
				else if( iPID == tsp->AUDIOPID ){
                    //A_ve[VĂpPbg
                    adpBytes = 0;
					if( tsp->nVideo[nBuffPoint + 3] & 0x20 ){
						adpBytes = tsp->nVideo[nBuffPoint + 4] + 1;
					}
					if( tsp->nVideo[nBuffPoint + 3] & 0x10 ){            //payload exists
						//pPbgX^[gR[h(000001)
						if( 0 == tsp->nVideo[nBuffPoint + adpBytes + 4] + tsp->nVideo[nBuffPoint + adpBytes + 5] ){
							if( 1 == tsp->nVideo[nBuffPoint + adpBytes + 6] ){
								if( 0x80 == (tsp->nVideo[nBuffPoint + adpBytes + 10] & 0xc0 )){
									if( tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0 ){       //'PTS=&H80 DTS=&H40
									//x = nVideo(nBuffPoint + adpBytes + 13) And &HF0			//PTS +DTS
										foundAudioPTS = true;
										break;
									}
								}
							}
						}
					}
				}
			}

			else if( iPID == tsp->PCRPID){
				//adaptation field exists
                if(  tsp->nVideo[nBuffPoint + 3] & 0x20 ){
					//PCR flag(adaptation Header field)
                    if( tsp->nVideo[nBuffPoint + 5] & 0x10 ){
                        foundPCR = true;
						break; 
					}
				}
			}

		}	// while

		if(0 == readSize){
			break;
		}

        //PTSPCR̓ PTSɂ PCRPTS菬
        if( foundVideoPTS ){
			//fPTS
			nowValuePTS = getValuePTS(tsp->nVideo,nBuffPoint,adpBytes);
            setValuePTS = nowValuePTS - tsp->difValueGOPPTSBASE;
            if( 0x1FFFFFFFFLL < setValuePTS ){
				setValuePTS = nowValuePTS - prevdifValueGOPPTSBASE;
			}
            setPTStoArray(tsp->nVideo,nBuffPoint,setValuePTS,adpBytes);
		}

        else if( foundGOP ){
			//PTS̏(GOP)
            prevValueGOPPTS = nowValueGOPPTS;
            nowValueGOPPTS = getValuePTS(tsp->nVideo,nBuffPoint,adpBytes);
            difValueGOPPTS = nowValueGOPPTS - prevValueGOPPTS;
            if( difValueGOPPTS < 0 ){      //bvAEh
				prevdifValueGOPPTSBASE = tsp->difValueGOPPTSBASE;
                tsp->difValueGOPPTSBASE -= 0x1FFFFFFFFLL;
			}
 			if( 1 < numGOP &&  900000 < difValueGOPPTS ){  //ȂڂƔf
				//PTS90kHz̃JE^Ȃ̂900001b
                bJoint = true;
				continue;
			}

			//PTS̐ݒ
			setValueGOPPTS = nowValueGOPPTS - tsp->difValueGOPPTSBASE;
			if( 0x1FFFFFFFFLL < setValueGOPPTS ){
				setValueGOPPTS = nowValueGOPPTS - prevdifValueGOPPTSBASE;
			}
			setPTStoArray(tsp->nVideo,nBuffPoint, setValueGOPPTS, adpBytes);
			//DTS̐ݒ
			nowValueDTS = getValueDTS(tsp->nVideo,nBuffPoint, adpBytes);
			setValueDTS = nowValueDTS - tsp->difValueGOPPTSBASE;
			if( 0x1FFFFFFFFLL < setValueDTS ){
				setValueDTS = nowValueDTS - prevdifValueGOPPTSBASE;
			}
			setDTStoArray( tsp->nVideo, nBuffPoint, setValueDTS, adpBytes);

		}

		else if( foundPCR ){
			//PCRݒ
            nowValuePCR = getValuePCR(tsp->nVideo,nBuffPoint);
            setValuePCR = nowValuePCR - tsp->difValueGOPPTSBASE * 300;
            if( 0x258000000D3LL < setValuePCR ){
				//&H1FFFFFFFF*300+&H1FF=&H258000000D3
				setValuePCR = nowValuePCR - prevdifValueGOPPTSBASE * 300;
			}
            setPCRtoArray(tsp->nVideo,nBuffPoint, setValuePCR);
 		}

        else if( foundAudioPTS ){
			//PTSݒ
            nowValuePTS = getValuePTS(tsp->nVideo,nBuffPoint, adpBytes);
            setValuePTS = nowValuePTS - tsp->difValueGOPPTSBASE;
            if( 0x1FFFFFFFFLL < setValuePTS ){
				setValuePTS = nowValuePTS - prevdifValueGOPPTSBASE;
			}
            setPTStoArray( tsp->nVideo, nBuffPoint, setValuePTS, adpBytes);
		}
	}

	fprintf(stdout,"PCR,PTS,DTSXV 100%% \n");
	fflush(stdout);
	return true;

}

